'use strict';

var styledComponents = require('styled-components');

function _taggedTemplateLiteral(strings, raw) {
  if (!raw) {
    raw = strings.slice(0);
  }

  return Object.freeze(Object.defineProperties(strings, {
    raw: {
      value: Object.freeze(raw)
    }
  }));
}

function _templateObject2() {
  var data = _taggedTemplateLiteral(["\n    html {\n      box-sizing: border-box;\n      font-size: 14px;\n      direction: ", ";\n    }\n    *,\n    *:before,\n    *:after {\n      box-sizing: inherit;\n    }\n    body {\n      margin: 0;\n      padding: 0;\n      text-align: ", ";\n      -webkit-font-smoothing: antialiased;\n    }\n    #oah-layout.with-search .scrollable-container {\n      position: relative;\n      z-index: 0;\n    }\n    #oah-layout.rotate-layout {\n      position: fixed;\n      overflow: hidden;\n      width: 100%;\n\n      .scrollable-container {\n        position: relative;\n        z-index: 10001;\n\n        transition: transform 0.5s cubic-bezier(0.2, 1, 0.3, 1);\n      }\n\n      &.with-search .scrollable-container {\n        transition: transform 0.5s cubic-bezier(0.2, 1, 0.3, 1);\n        transform-origin: 50vw 50vh;\n        transform: perspective(1000px) translate3d(0, 50vh, 0)\n          rotate3d(1, 0, 0, 30deg);\n        pointer-events: none;\n      }\n    }\n    #oah-layout.column-curtain.with-search .layout {\n      pointer-events: none;\n    }\n    #oah-layout.curtain .scrollable-container {\n      position: relative;\n      z-index: 0;\n    }\n    #oah-layout.modal-drop {\n      .layout {\n        position: relative;\n        transition: transform 0.4s, opacity 0.4s;\n        transition-timing-function: cubic-bezier(0.4, 0, 0.2, 1);\n      }\n      &.with-search .layout {\n        opacity: 0;\n        transform: scale3d(0.9, 0.9, 1);\n        pointer-events: none;\n      }\n    }\n\n    #oah-layout.modal-half {\n      .layout {\n        transition: transform 0.6s, opacity 0.6s;\n        transition-timing-function: cubic-bezier(0.2, 1, 0.3, 1);\n      }\n      &.with-search {\n        .layout {\n          transform: scale3d(0.8, 0.8, 1);\n          pointer-events: none;\n        }\n      }\n    }\n\n    #oah-layout.modal-move {\n      .layout {\n        transition: transform 0.5s;\n      }\n      &.with-search {\n        .layout {\n          transform: scale3d(0.8, 0.8, 1);\n          pointer-events: none;\n        }\n      }\n    }\n    *::-webkit-scrollbar {\n      width: ", ";\n      height: ", ";\n    }\n\n    *::-webkit-scrollbar-thumb {\n      background: ", ";\n      cursor: pointer;\n      border-radius: ", ";\n    }\n\n    *::-webkit-scrollbar-track {\n      background: ", ";\n    }\n  "]);

  _templateObject2 = function _templateObject2() {
    return data;
  };

  return data;
}

function _templateObject() {
  var data = _taggedTemplateLiteral(["\n  ", "\n"]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}
var GlobalStyle = styledComponents.css(_templateObject(), function (_ref) {
  var theme = _ref.theme;
  return styledComponents.css(_templateObject2(), theme.dir && theme.dir, theme.dir === 'rtl' ? 'right' : 'left', theme.scrollbarWidth, theme.scrollbarWidth, theme.scrollbarFg, theme.scrollbarThumbRadius, theme.scrollbarBg);
});

module.exports = GlobalStyle;
